package andererudpserver;

/**
 * Title:
 * Description: allgemeine Klasse fr die Implementation von UDP Servern
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
import java.net.*;
import java.io.*;

public class GenerellerUDPServer {

  protected static int defaultPort = 0;
  protected static int defaultBufferLength = 65507;

  public static void main(String[] args) {
    System.out.println("[GenerellerUDPServer]Start ");
    DatagramPacket incoming;

    int port;
    int len;

    try {
      port = Integer.parseInt(args[0]);
    }
    catch (Exception e) {
      port = defaultPort;
    }
    try {
      len = Integer.parseInt(args[1]);
    }
    catch (Exception e) {
      len = defaultBufferLength;
    }

    try {
      System.out.println("[GenerellerUDPServer]new DatagramSocket("+port+");");
      DatagramSocket ds = new DatagramSocket(port);
      byte[] buffer = new byte[len];
      while (true) {
        incoming = new DatagramPacket(buffer, buffer.length);
        try {
          ds.receive(incoming);
          respond(ds, incoming);
          System.out.println("[GenerellerUDPServer]Datagramm empfangen und beantwortet");
        }
        catch (IOException e) {
          System.err.println(e);
        }
      } // end while
    }  // end try
    catch (SocketException se) {
      System.err.println(se);
    }  // end catch
    System.out.println("[GenerellerUDPServer]Ende");
  }  // end main

  public static void respond(DatagramSocket ds, DatagramPacket dp) {
    ; // da mssen wir noch was hineinschreiben, damit wir einen Server erhalten
  }
}