package datagramsender;

/**
 * Title:
 * Description: Umwandlung einer Zeichenkette in ein Byte Array und
 * senden dieses Arrays an einen fix einprogrammierten Host
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
import java.net.*;
import java.io.*;

public class UDPDatagramSender {

  public static void main(String args[]) {
    System.out.println("[UDPDatagramServer]Start");
    String host = "localhost";
    int port = 7;
    if (args.length > 0) {
      host = args[0];
    } else System.out.println("[UDPDatagramServer]Dem Programm kann man zwei Parameter uebergeben : host und port");
    if (args.length > 1) {  // erstes Argument ist der Host; zweites der Port
      port = Integer.parseInt(args[1]);
    }
    System.out.println("[UDPDatagramServer]Parameter : host="+host+" und port="+port);

    String s = "Das ist ein Test.";
    byte[] data = new byte[s.length()];
    // bertragen der Daten (String) in den Byte Buffer data
    s.getBytes(0, s.length(), data, 0);
    try {
      InetAddress ia = InetAddress.getByName(host);
      DatagramPacket dp = new DatagramPacket(data, data.length, ia, port);
      System.out.println("[UDPDatagramServer]Paket Daten");
      System.out.println("[UDPDatagramServer]Address: "+dp.getAddress());
      System.out.println("[UDPDatagramServer]Port: "+dp.getPort());
      System.out.println("[UDPDatagramServer]Class: "+dp.getClass());
      // Umwandlung der Byte Daten (byte array) in Zeichen (char) durch Casting
      System.out.print("[UDPDatagramServer]Data:");
        for (int i=0; i<dp.getLength();i++) System.out.print((char)dp.getData()[i]);
      System.out.println();
      System.out.println("[UDPDatagramServer]Length: "+dp.getLength());
      System.out.println("[UDPDatagramServer]Offset: "+dp.getOffset());
      System.out.println("[UDPDatagramServer]Hashcode "+dp.hashCode());
      //System.out.println("[UDPDatagramServer]toString "+dp.toString());

      // Zusatz
      //DataInputStream dis = new DataInputStream(System.in);
      //String strEingabe=dis.readLine();
      //while (!strEingabe.equals(".")) {
      while(true) {
        //data = new byte[s.length()];
        dp = new DatagramPacket(data, data.length, ia, port);
        //strEingabe=dis.readLine();
      }
      // Ende Zusatz
    } catch (UnknownHostException e) {    }

      // Zusatz
      //catch (IOException ioe) {System.err.println("IOException "+ioe); }
      // Ende Zusatz
    System.out.println("[UDPDatagramServer]Ende");
  }
}