package multithreadingudpclient;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.net.*;
import java.io.*;

public class MultithreadingUDPClient {
  public static void main(String[] args) {
    System.out.println("[MultithreadingUDPClient]Start");
    String hostname="localhost";
    int echoPort = 7;

    if (args.length > 0) {
      hostname = args[0];
      if (args.length > 1) {
        echoPort =  Integer.parseInt(args[2]);
      }
      System.out.println("[MultithreadingUDPClient]Host = "+hostname+"; Port = "+echoPort);
    }
    else {
      System.out.println("[MultithreadingUDPClient]Das Programm hat zwei Parameter : Host und Port");
    }

    try {
       InetAddress ia = InetAddress.getByName(hostname);
       DatagramSocket theSocket = new DatagramSocket();
       echoEingabeThread eit = new echoEingabeThread(ia, theSocket);
       eit.start();
       echoAusgabeThread eot = new echoAusgabeThread(theSocket);
       eot.start();
    }
    catch (UnknownHostException e) {
      System.err.println(e);
    }
    catch (SocketException se) {
      System.err.println(se);
    }
    System.out.println("[MultithreadingUDPClient]Ende");
  }  // end main
}