package udpdaytimeclient;

//Titel:        UDP Klasse
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       J.M.Joller
//Beschreibung:  ein allgemeiner Client

import java.net.*;
import java.io.*;

public class UDPClient {

  protected static int defaultPort = 13;   // Standard Port : anonym
  protected static int bufferLength = 8192; // NFS abgeschaut

  public static void main(String[] args) {
    System.out.println("[UDPDaytimeClient]Start ");

    String hostname;
    int port;
    int len;

    if (args.length > 0) {
      hostname = args[0];
    }
    else {
      hostname = "localhost";
      port = defaultPort;
      len = bufferLength;
    }
    try {       // zur Abwechselung mal eine neue Variante
      port = Integer.parseInt(args[1]);
    }
    catch (Exception e) {
      port = defaultPort;
    }
    try {
      len = Integer.parseInt(args[2]);
    }
    catch (Exception e) {
      len = bufferLength;
    }

    try {
      System.out.println("[UDPDaytimeClient]Host="+hostname+"; Port="+port);
      DatagramSocket ds = new DatagramSocket(0);
      InetAddress ia = InetAddress.getByName(hostname);

      DatagramPacket outgoing = new DatagramPacket(new byte[512], 1, ia, port);
      DatagramPacket incoming = new DatagramPacket(new byte[len], len);
      ds.send(outgoing);
      System.out.println("[UDPDaytimeClient]DatagramSocket : Datagramm gesendet");
      ds.receive(incoming);
      System.out.println("[UDPDaytimeClient]DatagramSocket : Datagramm empfangen");
      System.out.println("[UDPDaytimeClient]"+new String(incoming.getData(), 0, 0, incoming.getLength()));
    }  // end try
    catch (UnknownHostException e) {
      System.err.println(e);
    }  // end catch
    catch (SocketException e) {
      System.err.println(e);
    }  // end catch
    catch (IOException e) {
      System.err.println(e);
    }  // end catch
    System.out.println("[UDPDaytimeClient]Ende");
  }  // end main
}