package udpdaytimeserver;

/**
 * Title:
 * Description:allgemeine Klasse fr die Implementation von UDPDaytime Servern
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.net.*;
import java.io.*;
import java.util.Date;

public class UDPDaytimeServer {

  protected static int defaultPort = 13;
  protected static int defaultBufferLength = 65507;

  public static void main(String[] args) {
    System.out.println("[UDPDaytimeServer]Start");
    DatagramPacket incoming;

    int port;
    int len;

    try {
      port = Integer.parseInt(args[0]);
    }
    catch (Exception e) {
      port = defaultPort;
    }
    try {
      len = Integer.parseInt(args[1]);
    }
    catch (Exception e) {
      len = defaultBufferLength;
    }

    try {
      DatagramSocket ds = new DatagramSocket(port);
      byte[] buffer = new byte[len];
      while (true) {
        incoming = new DatagramPacket(buffer, buffer.length);
        try {
          ds.receive(incoming);
          respond(ds, incoming); // siehe unten
          System.out.println("[UDPDaytimeServer]Datagramm empfangen und beantwortet");
        }
        catch (IOException e) {
          System.err.println(e);
        }
      } // end while
    }  // end try
    catch (SocketException se) {
      System.err.println(se);
    }  // end catch
    System.out.println("[UDPDaytimeServer]Ende");
  }  // end main

  public static void respond(DatagramSocket ds, DatagramPacket dp) {
    System.out.println("[UDPDaytimeServer]respond()");
    DatagramPacket outgoing;
    Date now = new Date();
    String s = now.toString();
    byte[] data = new byte[s.length()];
    s.getBytes(0, s.length(), data, 0);
    try {
      System.out.println("[UDPDaytimeServer]Time: "+s);
      outgoing = new DatagramPacket(data, data.length, dp.getAddress(), dp.getPort());
      ds.send(outgoing);
    }
    catch (IOException e) {
      System.err.println(e);
    }
  }
}