package udpsenderempfaenger;

/**
 * Title:public void send(DatagramPaket dp) throws IOException
 * Description: ein einfacher UDP Client / Server: Lesen der Daten ab
 * System.in (Konsole);Ausgabe der Daten als Datagramm ber UDP.
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.net.*;
import java.io.*;

public class UDPSendenUndEmpfangen {
  public static void main(String[] args) {
    System.out.println("[UDPSendenUndEmpfangen]Start");
    String host;
    int port;

    if (args.length > 0) {
      host = args[0];
    }
    else {
      System.out.println("[UDPSendenUndEmpfangen]Das Programm haette zwei Parameter : host und port");
      host = "localhost";
    }
    if (args.length > 1) {
      port = Integer.parseInt(args[1]);
    }
    else {
      port = 2048;
    }
    System.out.println("[UDPSendenUndEmpfangen]Host = "+host+"; Port = "+port);
    System.out.println("[UDPSendenUndEmpfangen]Geben Sie die zu uebermittelnden Daten ein\nAbbruch : durch Eingabe von '.'");

    try {

      String strEingabe;
      InetAddress iaServer = InetAddress.getByName(host);
      DatagramPacket dpOutput, dpInput = new DatagramPacket(new byte[512],512);
      DataInputStream userInput = new DataInputStream(System.in);
      DatagramSocket dsSocket = new DatagramSocket();
      while (true) {
        strEingabe = userInput.readLine();
        if (strEingabe.equals(".")) break; //  ich versuch's nochmal
        byte[] data = new byte[strEingabe.length()]; // Datagramm
        strEingabe.getBytes(0, strEingabe.length(), data, 0);
        dpOutput = new DatagramPacket(data, data.length, iaServer, port);
        dsSocket.send(dpOutput);
        System.out.println("[UDPSendenUndEmpfangen]Eingabedaten '"+strEingabe+"' per UDP versandt! Abbruch : '.' eingeben");
        System.out.println("[UDPSendenUndEmpfangen]Charakteristisken des Sockets:");
        //System.out.println("[UDPSendenUndEmpfangen]\tgetInetAddresss() "+dsSocket.getInetAddress().toString());
        System.out.println("[UDPSendenUndEmpfangen]\tgetLocalAddresss() "+dsSocket.getLocalAddress().toString());
        System.out.println("[UDPSendenUndEmpfangen]\tgetLocalPort() "+dsSocket.getLocalPort());
        System.out.println("[UDPSendenUndEmpfangen]\tgetPort() "+dsSocket.getPort());
      }  // end while
    }  // end try
    catch (UnknownHostException e) {
      System.err.println(e);
    }
    catch (SocketException se) {
      System.err.println(se);
    }
    catch (IOException e) {
      System.err.println(e);
    }
    System.out.println("[UDPSendenUndEmpfangen]Ende");
  }  // end main
}