package udpserver;

/**
 * Title:public void receive(DatagrammPacket dp) throws IOException
 * Description:Dieser "discard" Server hrt an einem UDP Port
 * (Default Port = 9)und schreibt die empfangenen Daten auf die Konsole.
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.net.*;
import java.io.*;

public class UDPServer {
  static byte[] buffer = new byte[512];

  public static void main(String[] args) {
    System.out.println("[UDPServer]Start ");
    String host;
    int port;

    if (args.length > 0) {
      host = args[0];
    }
    else {
      System.out.println("[UDPServer]Das Programm haette zwei Parameter : host und port");
      host = "localhost";
    }
    if (args.length > 1) {
      port = Integer.parseInt(args[1]);
    }
    else {
      port = 2048;
    }
    System.out.println("[UDPServer]Host = "+host+"; Port = "+port);
    System.out.println("[UDPServer]Der Server wartet auf Daten");

    try {
      DatagramSocket ds = new DatagramSocket(port);
      while (true) {
        try {
          DatagramPacket dp = new DatagramPacket(buffer, buffer.length);
          ds.receive(dp);
          String s = new String(dp.getData(), 0, 0, dp.getLength());
          System.out.println("[UDPServer]"+dp.getAddress() + " am Port " + dp.getPort() + " sagt " + s);
        }
        catch (IOException e) {
          System.err.println(e);
        }
       } // end while
    }  // end try
    catch (SocketException se) {
      System.err.println(se);
    }  // end catch
    System.out.println("[UDPServer]Ende ");
  }  // end main
}