package udpgetdatagram;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

//Beschreibung:  Definition eines einfachen Datagrammes
//Zuordnung einer Zeichenkette an das Datgramm
//"Versenden" des Datagrammes an einen Host und Port, welcher als Parameter bergeben wird
//Analyse des Datagrammes mit Hilfe der get Methoden

import java.net.*;

public class UDPgetDatagram {

  public static void main(String args[]) {
    System.out.println("[UDPgetDatagram]Start ");
    String s = "Hier stehen die Daten.";
    // Argumente
    String host = "localhost";
    int port = 7;
    if (args.length > 0) {
      host = args[0];
    } else System.out.println("[UDPgetDatagram]Dem Programm kann man zwei Parameter uebergeben : host und port");
    if (args.length > 1) {  // erstes Argument ist der Host; zweites der Port
      port = Integer.parseInt(args[1]);
    }
    System.out.println("[UDPgetDatagram]Parameter : host="+host+" und port="+port);
    // Byte Array fr das Datagramm
    byte[] data = new byte[s.length()];
    s.getBytes(0, s.length(), data, 0); // jetzt steht s im Byte Array
    try {
      InetAddress ia = InetAddress.getByName(host);
      DatagramPacket dp = new DatagramPacket(data, data.length, ia, port);
      System.out.println("[UDPgetDatagram]Dieses Paket ist adressiert an " + dp.getAddress() + " on port " + dp.getPort());
      System.out.println("[UDPgetDatagram]Es sind " + dp.getLength() + " Daten Bytes im Paket");
      System.out.print("[UDPgetDatagram] ... und hier die Rckbersetzung der Datagramm Daten:");
      System.out.println("[UDPgetDatagram]"+new String(dp.getData(), 0, 0, dp.getLength()));
    }
    catch (UnknownHostException e) {
      System.err.println(e);
    }
    System.out.println("[UDPgetDatagram]Ende");
  }
}